/* Copyright (C) Kevin Vance, June 26 2003.
 * Email winnocence@peacefire.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <windows.h>

#include "about.h"
#include "resource.h"

const char about_title[] = "About WINnocence";
const char about_class[] = "winnocenceAboutClass";
const int bmp_w = 399;
const int bmp_h = 150;
WNDCLASSEX ac;

/* Create our about window. */
void create_about_window(HWND parent)
{
	int scr_w = GetSystemMetrics(SM_CXSCREEN);
	int scr_h = GetSystemMetrics(SM_CYSCREEN);
	int pos_x = scr_w/2 - bmp_w/2;
	int pos_y = scr_h/2 - bmp_h/2;
	HWND about = CreateWindowEx(
			0,
			about_class,
			"About WINnocence",
			WS_POPUP,
			pos_x, pos_y,
			bmp_w, bmp_h,
			NULL,
			NULL,
			GetModuleHandle(NULL),
			NULL);
	ShowWindow(about, SW_SHOWNORMAL);
	UpdateWindow(about);
}

void init_about_window(HWND parent)
{
	HWND logo;
	HBITMAP bmp;

	/* Create logo graphic */
	logo = CreateWindowEx(WS_EX_TRANSPARENT, "STATIC", NULL,
			WS_CHILD | WS_VISIBLE | SS_BITMAP,
			0, 0,
			bmp_w, bmp_h,
			parent,
			NULL,
			GetModuleHandle(NULL),
			NULL);
	bmp = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(IDB_LOGO));
	SendMessage(logo, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)bmp);
}

/*********************/
/*   EVENT HANDLER   */
/*********************/
LRESULT CALLBACK AboutProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
		case WM_CREATE:
			init_about_window(hwnd);
			break;
		case WM_CLOSE:
			DestroyWindow(hwnd);
			break;
		case WM_LBUTTONDOWN:
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			break;
		default:
			return DefWindowProc(hwnd, msg, wParam, lParam);
	}
	return 0;
}
